--- xpdf-3.02/xpdf/SplashOutputDev.cc
+++ xpdf-3.02/xpdf/SplashOutputDev.cc
@@ -488,8 +488,8 @@
   int glyphW, glyphH;		// size of glyph bitmaps, in pixels
   GBool validBBox;		// false if the bbox was [0 0 0 0]
   int glyphSize;		// size of glyph bitmaps, in bytes
-  int cacheSets;		// number of sets in cache
-  int cacheAssoc;		// cache associativity (glyphs per set)
+  SafeInt cacheSets;		// number of sets in cache
+  SafeInt cacheAssoc;		// cache associativity (glyphs per set)
   Guchar *cacheData;		// glyph pixmap cache
   T3FontCacheTag *cacheTags;	// cache tags, i.e., char codes
 };
@@ -529,7 +529,7 @@
   cacheTags = (T3FontCacheTag *)gmallocn(cacheSets * cacheAssoc,
 					 sizeof(T3FontCacheTag));
   for (i = 0; i < cacheSets * cacheAssoc; ++i) {
-    cacheTags[i].mru = i & (cacheAssoc - 1);
+    cacheTags[i].mru = i & (cacheAssoc.Int() - 1);
   }
 }
 
@@ -1537,7 +1537,7 @@
   t3Font = t3FontCache[0];
 
   // is the glyph in the cache?
-  i = (code & (t3Font->cacheSets - 1)) * t3Font->cacheAssoc;
+  i = (code & (t3Font->cacheSets.Int() - 1)) * t3Font->cacheAssoc.Int();
   for (j = 0; j < t3Font->cacheAssoc; ++j) {
     if ((t3Font->cacheTags[i+j].mru & 0x8000) &&
 	t3Font->cacheTags[i+j].code == code) {
@@ -1644,7 +1644,7 @@
   }
 
   // allocate a cache entry
-  i = (t3GlyphStack->code & (t3Font->cacheSets - 1)) * t3Font->cacheAssoc;
+  i = (t3GlyphStack->code & (t3Font->cacheSets.Int() - 1)) * t3Font->cacheAssoc.Int();
   for (j = 0; j < t3Font->cacheAssoc; ++j) {
     if ((t3Font->cacheTags[i+j].mru & 0x7fff) == t3Font->cacheAssoc - 1) {
       t3Font->cacheTags[i+j].mru = 0x8000;
@@ -2008,7 +2008,7 @@
   // build a lookup table here
   imgData.lookup = NULL;
   if (colorMap->getNumPixelComps() == 1) {
-    n = 1 << colorMap->getBits();
+    n = (SafeInt(1) << colorMap->getBits()).Int();
     switch (colorMode) {
     case splashModeMono1:
     case splashModeMono8:
@@ -2021,7 +2021,7 @@
       break;
     case splashModeRGB8:
     case splashModeBGR8:
-      imgData.lookup = (SplashColorPtr)gmalloc(3 * n);
+      imgData.lookup = (SplashColorPtr)gmallocn(3, n);
       for (i = 0; i < n; ++i) {
 	pix = (Guchar)i;
 	colorMap->getRGB(&pix, &rgb);
@@ -2032,7 +2032,7 @@
       break;
 #if SPLASH_CMYK
     case splashModeCMYK8:
-      imgData.lookup = (SplashColorPtr)gmalloc(4 * n);
+      imgData.lookup = (SplashColorPtr)gmallocn(4, n);
       for (i = 0; i < n; ++i) {
 	pix = (Guchar)i;
 	colorMap->getCMYK(&pix, &cmyk);
@@ -2252,7 +2252,7 @@
     // build a lookup table here
     imgData.lookup = NULL;
     if (colorMap->getNumPixelComps() == 1) {
-      n = 1 << colorMap->getBits();
+      n = (SafeInt(1) << colorMap->getBits()).Int();
       switch (colorMode) {
       case splashModeMono1:
       case splashModeMono8:
@@ -2265,7 +2265,7 @@
 	break;
       case splashModeRGB8:
       case splashModeBGR8:
-	imgData.lookup = (SplashColorPtr)gmalloc(3 * n);
+	imgData.lookup = (SplashColorPtr)gmallocn(3, n);
 	for (i = 0; i < n; ++i) {
 	  pix = (Guchar)i;
 	  colorMap->getRGB(&pix, &rgb);
@@ -2276,7 +2276,7 @@
 	break;
 #if SPLASH_CMYK
       case splashModeCMYK8:
-	imgData.lookup = (SplashColorPtr)gmalloc(4 * n);
+	imgData.lookup = (SplashColorPtr)gmallocn(4, n);
 	for (i = 0; i < n; ++i) {
 	  pix = (Guchar)i;
 	  colorMap->getCMYK(&pix, &cmyk);
@@ -2347,7 +2347,7 @@
   imgMaskData.width = maskWidth;
   imgMaskData.height = maskHeight;
   imgMaskData.y = 0;
-  n = 1 << maskColorMap->getBits();
+  n = (SafeInt(1) << maskColorMap->getBits()).Int();
   imgMaskData.lookup = (SplashColorPtr)gmalloc(n);
   for (i = 0; i < n; ++i) {
     pix = (Guchar)i;
@@ -2384,7 +2384,7 @@
   // build a lookup table here
   imgData.lookup = NULL;
   if (colorMap->getNumPixelComps() == 1) {
-    n = 1 << colorMap->getBits();
+    n = (SafeInt(1) << colorMap->getBits()).Int();
     switch (colorMode) {
     case splashModeMono1:
     case splashModeMono8:
@@ -2397,7 +2397,7 @@
       break;
     case splashModeRGB8:
     case splashModeBGR8:
-      imgData.lookup = (SplashColorPtr)gmalloc(3 * n);
+      imgData.lookup = (SplashColorPtr)gmallocn(3, n);
       for (i = 0; i < n; ++i) {
 	pix = (Guchar)i;
 	colorMap->getRGB(&pix, &rgb);
@@ -2408,7 +2408,7 @@
       break;
 #if SPLASH_CMYK
     case splashModeCMYK8:
-      imgData.lookup = (SplashColorPtr)gmalloc(4 * n);
+      imgData.lookup = (SplashColorPtr)gmallocn(4, n);
       for (i = 0; i < n; ++i) {
 	pix = (Guchar)i;
 	colorMap->getCMYK(&pix, &cmyk);
--- xpdf-3.02/xpdf/Stream.cc
+++ xpdf-3.02/xpdf/Stream.cc
@@ -319,7 +319,7 @@
 
   nVals = width * nComps;
   if (nBits == 1) {
-    imgLineSize = (nVals + 7) & ~7;
+    imgLineSize = (SafeInt(nVals) + SafeInt(7)).Int() & ~7;
   } else {
     imgLineSize = nVals;
   }
@@ -492,7 +492,7 @@
       break;
     case 13:			// PNG average
       predLine[i] = ((predLine[i - pixBytes] + predLine[i]) >> 1) +
-	            (Guchar)c;
+		    (Guchar)c;
       break;
     case 14:			// PNG Paeth
       left = predLine[i - pixBytes];
@@ -1253,8 +1253,8 @@
   // ---> max codingLine size = columns + 1
   // refLine has one extra guard entry at the end
   // ---> max refLine size = columns + 2
-  codingLine = (int *)gmallocn(columns + 1, sizeof(int));
-  refLine = (int *)gmallocn(columns + 2, sizeof(int));
+  codingLine = (int *)gmallocn(SafeInt(columns) + SafeInt(1), sizeof(int));
+  refLine = (int *)gmallocn(SafeInt(columns) + SafeInt(2), sizeof(int));
 
   eof = gFalse;
   row = 0;
@@ -1969,7 +1969,7 @@
   restartInterval = 0;
 
   if (!readHeader()) {
-    y = height;
+    y = height.Int();
     return;
   }
 
@@ -2014,12 +2014,12 @@
     if (bufWidth <= 0 || bufHeight <= 0 ||
 	bufWidth > INT_MAX / bufWidth / (int)sizeof(int)) {
       error(getPos(), "Invalid image size in DCT stream");
-      y = height;
+      y = height.Int();
       return;
     }
     for (i = 0; i < numComps; ++i) {
       frameBuf[i] = (int *)gmallocn(bufWidth * bufHeight, sizeof(int));
-      memset(frameBuf[i], 0, bufWidth * bufHeight * sizeof(int));
+      memset(frameBuf[i], 0, (bufWidth * bufHeight * sizeof(int)).Int());
     }
 
     // read the image data
@@ -2051,7 +2051,7 @@
     comp = 0;
     x = 0;
     y = 0;
-    dy = mcuHeight;
+    dy = mcuHeight.Int();
 
     restartMarker = 0xd0;
     restart();
@@ -2079,7 +2079,7 @@
     return EOF;
   }
   if (progressive || !interleaved) {
-    c = frameBuf[comp][y * bufWidth + x];
+    c = frameBuf[comp][y * bufWidth.Int() + x];
     if (++comp == numComps) {
       comp = 0;
       if (++x == width) {
@@ -2090,7 +2090,7 @@
   } else {
     if (dy >= mcuHeight) {
       if (!readMCURow()) {
-	y = height;
+	y = height.Int();
 	return EOF;
       }
       comp = 0;
@@ -2118,11 +2118,11 @@
     return EOF;
   }
   if (progressive || !interleaved) {
-    return frameBuf[comp][y * bufWidth + x];
+    return frameBuf[comp][y * bufWidth.Int() + x];
   } else {
     if (dy >= mcuHeight) {
       if (!readMCURow()) {
-	y = height;
+	y = height.Int();
 	return EOF;
       }
       comp = 0;
@@ -2154,7 +2154,7 @@
   int x1, x2, y2, x3, y3, x4, y4, x5, y5, cc, i;
   int c;
 
-  for (x1 = 0; x1 < width; x1 += mcuWidth) {
+  for (x1 = 0; x1 < width; x1 += mcuWidth.Int()) {
 
     // deal with restart marker
     if (restartInterval > 0 && restartCtr == 0) {
@@ -2172,8 +2172,8 @@
     for (cc = 0; cc < numComps; ++cc) {
       h = compInfo[cc].hSample;
       v = compInfo[cc].vSample;
-      horiz = mcuWidth / h;
-      vert = mcuHeight / v;
+      horiz = mcuWidth.Int() / h;
+      vert = mcuHeight.Int() / v;
       hSub = horiz / 8;
       vSub = vert / 8;
       for (y2 = 0; y2 < mcuHeight; y2 += vert) {
@@ -2279,11 +2279,11 @@
 	break;
       }
     }
-    dx1 = mcuWidth / compInfo[cc].hSample;
-    dy1 = mcuHeight / compInfo[cc].vSample;
+    dx1 = mcuWidth.Int() / compInfo[cc].hSample;
+    dy1 = mcuHeight.Int() / compInfo[cc].vSample;
   } else {
-    dx1 = mcuWidth;
-    dy1 = mcuHeight;
+    dx1 = mcuWidth.Int();
+    dy1 = mcuHeight.Int();
   }
 
   for (y1 = 0; y1 < height; y1 += dy1) {
@@ -2310,14 +2310,14 @@
 
 	h = compInfo[cc].hSample;
 	v = compInfo[cc].vSample;
-	horiz = mcuWidth / h;
-	vert = mcuHeight / v;
+	horiz = mcuWidth.Int() / h;
+	vert = mcuHeight.Int() / v;
 	vSub = vert / 8;
 	for (y2 = 0; y2 < dy1; y2 += vert) {
 	  for (x2 = 0; x2 < dx1; x2 += horiz) {
 
 	    // pull out the current values
-	    p1 = &frameBuf[cc][(y1+y2) * bufWidth + (x1+x2)];
+	    p1 = &frameBuf[cc][(y1+y2) * bufWidth.Int() + (x1+x2)];
 	    for (y3 = 0, i = 0; y3 < 8; ++y3, i += 8) {
 	      data[i] = p1[0];
 	      data[i+1] = p1[1];
@@ -2327,7 +2327,7 @@
 	      data[i+5] = p1[5];
 	      data[i+6] = p1[6];
 	      data[i+7] = p1[7];
-	      p1 += bufWidth * vSub;
+	      p1 += bufWidth.Int() * vSub;
 	    }
 
 	    // read one data unit
@@ -2349,7 +2349,7 @@
 	    }
 
 	    // add the data unit into frameBuf
-	    p1 = &frameBuf[cc][(y1+y2) * bufWidth + (x1+x2)];
+	    p1 = &frameBuf[cc][(y1+y2) * bufWidth.Int() + (x1+x2)];
 	    for (y3 = 0, i = 0; y3 < 8; ++y3, i += 8) {
 	      p1[0] = data[i];
 	      p1[1] = data[i+1];
@@ -2359,7 +2359,7 @@
 	      p1[5] = data[i+5];
 	      p1[6] = data[i+6];
 	      p1[7] = data[i+7];
-	      p1 += bufWidth * vSub;
+	      p1 += bufWidth.Int() * vSub;
 	    }
 	  }
 	}
@@ -2556,21 +2556,21 @@
   int h, v, horiz, vert, hSub, vSub;
   int *p0, *p1, *p2;
 
-  for (y1 = 0; y1 < bufHeight; y1 += mcuHeight) {
-    for (x1 = 0; x1 < bufWidth; x1 += mcuWidth) {
+  for (y1 = 0; y1 < bufHeight; y1 += mcuHeight.Int()) {
+    for (x1 = 0; x1 < bufWidth; x1 += mcuWidth.Int()) {
       for (cc = 0; cc < numComps; ++cc) {
 	quantTable = quantTables[compInfo[cc].quantTable];
 	h = compInfo[cc].hSample;
 	v = compInfo[cc].vSample;
-	horiz = mcuWidth / h;
-	vert = mcuHeight / v;
+	horiz = mcuWidth.Int() / h;
+	vert = mcuHeight.Int() / v;
 	hSub = horiz / 8;
 	vSub = vert / 8;
 	for (y2 = 0; y2 < mcuHeight; y2 += vert) {
 	  for (x2 = 0; x2 < mcuWidth; x2 += horiz) {
 
 	    // pull out the coded data unit
-	    p1 = &frameBuf[cc][(y1+y2) * bufWidth + (x1+x2)];
+	    p1 = &frameBuf[cc][(y1+y2) * bufWidth.Int() + (x1+x2)];
 	    for (y3 = 0, i = 0; y3 < 8; ++y3, i += 8) {
 	      dataIn[i]   = p1[0];
 	      dataIn[i+1] = p1[1];
@@ -2580,7 +2580,7 @@
 	      dataIn[i+5] = p1[5];
 	      dataIn[i+6] = p1[6];
 	      dataIn[i+7] = p1[7];
-	      p1 += bufWidth * vSub;
+	      p1 += bufWidth.Int() * vSub;
 	    }
 
 	    // transform
@@ -2588,7 +2588,7 @@
 
 	    // store back into frameBuf, doing replication for
 	    // subsampled components
-	    p1 = &frameBuf[cc][(y1+y2) * bufWidth + (x1+x2)];
+	    p1 = &frameBuf[cc][(y1+y2) * bufWidth.Int() + (x1+x2)];
 	    if (hSub == 1 && vSub == 1) {
 	      for (y3 = 0, i = 0; y3 < 8; ++y3, i += 8) {
 		p1[0] = dataOut[i] & 0xff;
@@ -2599,10 +2599,10 @@
 		p1[5] = dataOut[i+5] & 0xff;
 		p1[6] = dataOut[i+6] & 0xff;
 		p1[7] = dataOut[i+7] & 0xff;
-		p1 += bufWidth;
+		p1 += bufWidth.Int();
 	      }
 	    } else if (hSub == 2 && vSub == 2) {
-	      p2 = p1 + bufWidth;
+	      p2 = p1 + bufWidth.Int();
 	      for (y3 = 0, i = 0; y3 < 16; y3 += 2, i += 8) {
 		p1[0] = p1[1] = p2[0] = p2[1] = dataOut[i] & 0xff;
 		p1[2] = p1[3] = p2[2] = p2[3] = dataOut[i+1] & 0xff;
@@ -2612,8 +2612,8 @@
 		p1[10] = p1[11] = p2[10] = p2[11] = dataOut[i+5] & 0xff;
 		p1[12] = p1[13] = p2[12] = p2[13] = dataOut[i+6] & 0xff;
 		p1[14] = p1[15] = p2[14] = p2[15] = dataOut[i+7] & 0xff;
-		p1 += bufWidth * 2;
-		p2 += bufWidth * 2;
+		p1 += bufWidth.Int() * 2;
+		p2 += bufWidth.Int() * 2;
 	      }
 	    } else {
 	      i = 0;
@@ -2624,11 +2624,11 @@
 		    for (x5 = 0; x5 < hSub; ++x5) {
 		      p2[x5] = dataOut[i] & 0xff;
 		    }
-		    p2 += bufWidth;
+		    p2 += bufWidth.Int();
 		  }
 		  ++i;
 		}
-		p1 += bufWidth * vSub;
+		p1 += bufWidth.Int() * vSub;
 	      }
 	    }
 	  }
@@ -2640,9 +2640,9 @@
 	// convert YCbCr to RGB
 	if (numComps == 3) {
 	  for (y2 = 0; y2 < mcuHeight; ++y2) {
-	    p0 = &frameBuf[0][(y1+y2) * bufWidth + x1];
-	    p1 = &frameBuf[1][(y1+y2) * bufWidth + x1];
-	    p2 = &frameBuf[2][(y1+y2) * bufWidth + x1];
+	    p0 = &frameBuf[0][(y1+y2) * bufWidth.Int() + x1];
+	    p1 = &frameBuf[1][(y1+y2) * bufWidth.Int() + x1];
+	    p2 = &frameBuf[2][(y1+y2) * bufWidth.Int() + x1];
 	    for (x2 = 0; x2 < mcuWidth; ++x2) {
 	      pY = *p0;
 	      pCb = *p1 - 128;
@@ -2659,9 +2659,9 @@
 	// convert YCbCrK to CMYK (K is passed through unchanged)
 	} else if (numComps == 4) {
 	  for (y2 = 0; y2 < mcuHeight; ++y2) {
-	    p0 = &frameBuf[0][(y1+y2) * bufWidth + x1];
-	    p1 = &frameBuf[1][(y1+y2) * bufWidth + x1];
-	    p2 = &frameBuf[2][(y1+y2) * bufWidth + x1];
+	    p0 = &frameBuf[0][(y1+y2) * bufWidth.Int() + x1];
+	    p1 = &frameBuf[1][(y1+y2) * bufWidth.Int() + x1];
+	    p2 = &frameBuf[2][(y1+y2) * bufWidth.Int() + x1];
 	    for (x2 = 0; x2 < mcuWidth; ++x2) {
 	      pY = *p0;
 	      pCb = *p1 - 128;
@@ -4321,7 +4321,7 @@
   }
 
   // allocate the table
-  tabSize = 1 << tab->maxLen;
+  tabSize = (SafeInt(1) << tab->maxLen).Int();
   tab->codes = (FlateCode *)gmallocn(tabSize, sizeof(FlateCode));
 
   // clear the table
--- xpdf-3.02/xpdf/Stream.h
+++ xpdf-3.02/xpdf/Stream.h
@@ -592,9 +592,9 @@
 
   GBool progressive;		// set if in progressive mode
   GBool interleaved;		// set if in interleaved mode
-  int width, height;		// image size
-  int mcuWidth, mcuHeight;	// size of min coding unit, in data units
-  int bufWidth, bufHeight;	// frameBuf size
+  SafeInt width, height;	// image size
+  SafeInt mcuWidth, mcuHeight;	// size of min coding unit, in data units
+  SafeInt bufWidth, bufHeight;	// frameBuf size
   DCTCompInfo compInfo[4];	// info for each component
   DCTScanInfo scanInfo;		// info for the current scan
   int numComps;			// number of components in image
--- xpdf-3.02/xpdf/TextOutputDev.cc
+++ xpdf-3.02/xpdf/TextOutputDev.cc
@@ -263,7 +263,7 @@
   }
   text = NULL;
   edge = NULL;
-  len = size = 0;
+  size = len = 0;
   spaceAfter = gFalse;
   next = NULL;
 
@@ -346,9 +346,9 @@
     yMax = word->yMax;
   }
   if (len + word->len > size) {
-    size = len + word->len;
+    size = SafeInt(len) + SafeInt(word->len);
     text = (Unicode *)greallocn(text, size, sizeof(Unicode));
-    edge = (double *)greallocn(edge, size + 1, sizeof(double));
+    edge = (double *)greallocn(edge, size + SafeInt(1), sizeof(double));
   }
   for (i = 0; i < word->len; ++i) {
     text[len + i] = word->text[i];
@@ -481,11 +481,11 @@
 }
 
 TextPool::~TextPool() {
-  int baseIdx;
+  SafeInt baseIdx;
   TextWord *word, *word2;
 
   for (baseIdx = minBaseIdx; baseIdx <= maxBaseIdx; ++baseIdx) {
-    for (word = pool[baseIdx - minBaseIdx]; word; word = word2) {
+    for (word = pool[(baseIdx - minBaseIdx).Int()]; word; word = word2) {
       word2 = word->next;
       delete word;
     }
@@ -498,17 +498,17 @@
 
   baseIdx = (int)(base / textPoolStep);
   if (baseIdx < minBaseIdx) {
-    return minBaseIdx;
+    return minBaseIdx.Int();
   }
   if (baseIdx > maxBaseIdx) {
-    return maxBaseIdx;
+    return maxBaseIdx.Int();
   }
   return baseIdx;
 }
 
 void TextPool::addWord(TextWord *word) {
   TextWord **newPool;
-  int wordBaseIdx, newMinBaseIdx, newMaxBaseIdx, baseIdx;
+  SafeInt wordBaseIdx, newMinBaseIdx, newMaxBaseIdx, baseIdx;
   TextWord *w0, *w1;
 
   // expand the array if needed
@@ -516,29 +516,29 @@
   if (minBaseIdx > maxBaseIdx) {
     minBaseIdx = wordBaseIdx - 128;
     maxBaseIdx = wordBaseIdx + 128;
-    pool = (TextWord **)gmallocn(maxBaseIdx - minBaseIdx + 1,
+    pool = (TextWord **)gmallocn(maxBaseIdx - minBaseIdx + SafeInt(1),
 				 sizeof(TextWord *));
     for (baseIdx = minBaseIdx; baseIdx <= maxBaseIdx; ++baseIdx) {
-      pool[baseIdx - minBaseIdx] = NULL;
+      pool[(baseIdx - minBaseIdx).Int()] = NULL;
     }
   } else if (wordBaseIdx < minBaseIdx) {
     newMinBaseIdx = wordBaseIdx - 128;
-    newPool = (TextWord **)gmallocn(maxBaseIdx - newMinBaseIdx + 1,
+    newPool = (TextWord **)gmallocn(maxBaseIdx - newMinBaseIdx + SafeInt(1),
 				    sizeof(TextWord *));
     for (baseIdx = newMinBaseIdx; baseIdx < minBaseIdx; ++baseIdx) {
-      newPool[baseIdx - newMinBaseIdx] = NULL;
+      newPool[(baseIdx - newMinBaseIdx).Int()] = NULL;
     }
-    memcpy(&newPool[minBaseIdx - newMinBaseIdx], pool,
-	   (maxBaseIdx - minBaseIdx + 1) * sizeof(TextWord *));
+    memcpy(&newPool[(minBaseIdx - newMinBaseIdx).Int()], pool,
+	   ((maxBaseIdx - minBaseIdx + 1) * sizeof(TextWord *)).Int());
     gfree(pool);
     pool = newPool;
     minBaseIdx = newMinBaseIdx;
   } else if (wordBaseIdx > maxBaseIdx) {
     newMaxBaseIdx = wordBaseIdx + 128;
-    pool = (TextWord **)greallocn(pool, newMaxBaseIdx - minBaseIdx + 1,
+    pool = (TextWord **)greallocn(pool, newMaxBaseIdx - minBaseIdx + SafeInt(1),
 				  sizeof(TextWord *));
     for (baseIdx = maxBaseIdx + 1; baseIdx <= newMaxBaseIdx; ++baseIdx) {
-      pool[baseIdx - minBaseIdx] = NULL;
+      pool[(baseIdx - minBaseIdx).Int()] = NULL;
     }
     maxBaseIdx = newMaxBaseIdx;
   }
@@ -550,17 +550,17 @@
     w1 = cursor->next;
   } else {
     w0 = NULL;
-    w1 = pool[wordBaseIdx - minBaseIdx];
+    w1 = pool[(wordBaseIdx - minBaseIdx).Int()];
   }
   for (; w1 && word->primaryCmp(w1) > 0; w0 = w1, w1 = w1->next) ;
   word->next = w1;
   if (w0) {
     w0->next = word;
   } else {
-    pool[wordBaseIdx - minBaseIdx] = word;
+    pool[(wordBaseIdx - minBaseIdx).Int()] = word;
   }
   cursor = word;
-  cursorBaseIdx = wordBaseIdx;
+  cursorBaseIdx = wordBaseIdx.Int();
 }
 
 //------------------------------------------------------------------------
@@ -763,7 +763,7 @@
     }
   }
   text = (Unicode *)gmallocn(len, sizeof(Unicode));
-  edge = (double *)gmallocn(len + 1, sizeof(double));
+  edge = (double *)gmallocn(len + SafeInt(1), sizeof(double));
   i = 0;
   for (word1 = words; word1; word1 = word1->next) {
     for (j = 0; j < word1->len; ++j) {
@@ -779,7 +779,7 @@
   }
 
   // compute convertedLen and set up the col array
-  col = (int *)gmallocn(len + 1, sizeof(int));
+  col = (int *)gmallocn(len + SafeInt(1), sizeof(int));
   convertedLen = 0;
   for (i = 0; i < len; ++i) {
     col[i] = convertedLen;
@@ -789,11 +789,11 @@
       convertedLen += uMap->mapUnicode(text[i], buf, sizeof(buf));
     }
   }
-  col[len] = convertedLen;
+  col[len.Int()] = convertedLen;
 
   // check for hyphen at end of line
   //~ need to check for other chars used as hyphens
-  hyphenated = text[len - 1] == (Unicode)'-';
+  hyphenated = text[(len - 1).Int()] == (Unicode)'-';
 }
 
 //------------------------------------------------------------------------
@@ -1163,7 +1163,7 @@
   int i, j, k;
 
   // discard duplicated text (fake boldface, drop shadows)
-  for (idx0 = pool->minBaseIdx; idx0 <= pool->maxBaseIdx; ++idx0) {
+  for (idx0 = pool->minBaseIdx.Int(); idx0 <= pool->maxBaseIdx.Int(); ++idx0) {
     word0 = pool->getPool(idx0);
     while (word0) {
       priDelta = dupMaxPriDelta * word0->fontSize;
@@ -1227,7 +1227,7 @@
 
   // build the lines
   curLine = NULL;
-  poolMinBaseIdx = pool->minBaseIdx;
+  poolMinBaseIdx = pool->minBaseIdx.Int();
   charCount = 0;
   nLines = 0;
   while (1) {
@@ -1329,7 +1329,7 @@
     line->next = line1;
     curLine = line;
     line->coalesce(uMap);
-    charCount += line->len;
+    charCount += line->len.Int();
     ++nLines;
   }
 
@@ -1338,7 +1338,7 @@
   for (line = lines, i = 0; line; line = line->next, ++i) {
     lineArray[i] = line;
   }
-  qsort(lineArray, nLines, sizeof(TextLine *), &TextLine::cmpXY);
+  qsort(lineArray, nLines.Int(), sizeof(TextLine *), &TextLine::cmpXY);
 
   // column assignment
   nColumns = 0;
@@ -1348,7 +1348,7 @@
     for (j = 0; j < i; ++j) {
       line1 = lineArray[j];
       if (line1->primaryDelta(line0) >= 0) {
-	col2 = line1->col[line1->len] + 1;
+	col2 = line1->col[line1->len.Int()] + 1;
       } else {
 	k = 0; // make gcc happy
 	switch (rot) {
@@ -1386,8 +1386,8 @@
     for (k = 0; k <= line0->len; ++k) {
       line0->col[k] += col1;
     }
-    if (line0->col[line0->len] > nColumns) {
-      nColumns = line0->col[line0->len];
+    if (line0->col[line0->len.Int()] > nColumns) {
+      nColumns = line0->col[line0->len.Int()];
     }
   }
   gfree(lineArray);
@@ -1660,7 +1660,8 @@
   TextLine *line;
   TextWord *word;
   TextWord **wordArray;
-  int nWords, i;
+  SafeInt nWords;
+  int i;
 
   words = new GList();
 
@@ -2125,7 +2126,8 @@
   GBool found;
   int count[4];
   int lrCount;
-  int firstBlkIdx, nBlocksLeft;
+  int firstBlkIdx;
+  SafeInt nBlocksLeft;
   int col1, col2;
   int i, j, n;
 
@@ -2311,7 +2313,7 @@
   // build blocks for each rotation value
   for (rot = 0; rot < 4; ++rot) {
     pool = pools[rot];
-    poolMinBaseIdx = pool->minBaseIdx;
+    poolMinBaseIdx = pool->minBaseIdx.Int();
     count[rot] = 0;
 
     // add blocks until no more words are left
@@ -2679,7 +2681,7 @@
   for (blk = blkList, i = 0; blk; blk = blk->next, ++i) {
     blocks[i] = blk;
   }
-  qsort(blocks, nBlocks, sizeof(TextBlock *), &TextBlock::cmpXYPrimaryRot);
+  qsort(blocks, nBlocks.Int(), sizeof(TextBlock *), &TextBlock::cmpXYPrimaryRot);
 
   // column assignment
   for (i = 0; i < nBlocks; ++i) {
@@ -2771,7 +2773,7 @@
   //----- reading order sort
 
   // sort blocks into yx order (in preparation for reading order sort)
-  qsort(blocks, nBlocks, sizeof(TextBlock *), &TextBlock::cmpYXPrimaryRot);
+  qsort(blocks, nBlocks.Int(), sizeof(TextBlock *), &TextBlock::cmpYXPrimaryRot);
 
   // compute space on left and right sides of each block
   for (i = 0; i < nBlocks; ++i) {
@@ -2811,7 +2813,7 @@
   //~ this needs to be adjusted for writing mode (vertical text)
   //~ this also needs to account for right-to-left column ordering
   blkArray = (TextBlock **)gmallocn(nBlocks, sizeof(TextBlock *));
-  memcpy(blkArray, blocks, nBlocks * sizeof(TextBlock *));
+  memcpy(blkArray, blocks, nBlocks.Int() * sizeof(TextBlock *));
   flows = lastFlow = NULL;
   firstBlkIdx = 0;
   nBlocksLeft = nBlocks;
@@ -2983,7 +2985,7 @@
   xMin0 = xMax0 = yMin0 = yMax0 = 0; // make gcc happy
   xMin1 = xMax1 = yMin1 = yMax1 = 0; // make gcc happy
 
-  for (i = backward ? nBlocks - 1 : 0;
+  for (i = backward ? (nBlocks - 1).Int() : 0;
        backward ? i >= 0 : i < nBlocks;
        i += backward ? -1 : 1) {
     blk = blocks[i];
@@ -3013,7 +3015,7 @@
       }
 
       // convert the line to uppercase
-      m = line->len;
+      m = line->len.Int();
       if (!caseSensitive) {
 	if (m > txtSize) {
 	  txt = (Unicode *)greallocn(txt, m, sizeof(Unicode));
@@ -3134,7 +3136,8 @@
   TextBlock *blk;
   TextLine *line;
   TextLineFrag *frags;
-  int nFrags, fragsSize;
+  int nFrags;
+  SafeInt fragsSize;
   TextLineFrag *frag;
   char space[8], eol[16];
   int spaceLen, eolLen;
@@ -3197,7 +3200,7 @@
 		}
 		++j;
 	      }
-	      j = line->len - 1;
+	      j = (line->len - 1).Int();
 	      while (j >= 0) {
 		if (0.5 * (line->edge[j] + line->edge[j+1]) < xMax) {
 		  idx1 = j;
@@ -3218,7 +3221,7 @@
 		}
 		++j;
 	      }
-	      j = line->len - 1;
+	      j = (line->len - 1).Int();
 	      while (j >= 0) {
 		if (0.5 * (line->edge[j] + line->edge[j+1]) < yMax) {
 		  idx1 = j;
@@ -3239,7 +3242,7 @@
 		}
 		++j;
 	      }
-	      j = line->len - 1;
+	      j = (line->len - 1).Int();
 	      while (j >= 0) {
 		if (0.5 * (line->edge[j] + line->edge[j+1]) > xMin) {
 		  idx1 = j;
@@ -3260,7 +3263,7 @@
 		}
 		++j;
 	      }
-	      j = line->len - 1;
+	      j = (line->len - 1).Int();
 	      while (j >= 0) {
 		if (0.5 * (line->edge[j] + line->edge[j+1]) > yMin) {
 		  idx1 = j;
@@ -3449,7 +3452,8 @@
   TextLine *line;
   TextLineFrag *frags;
   TextWord *word;
-  int nFrags, fragsSize;
+  int nFrags;
+  SafeInt fragsSize;
   TextLineFrag *frag;
   char space[8], eol[16], eop[8];
   int spaceLen, eolLen, eopLen;
@@ -3515,7 +3519,7 @@
 	  frags = (TextLineFrag *)greallocn(frags,
 					    fragsSize, sizeof(TextLineFrag));
 	}
-	frags[nFrags].init(line, 0, line->len);
+	frags[nFrags].init(line, 0, line->len.Int());
 	frags[nFrags].computeCoords(gTrue);
 	++nFrags;
       }
@@ -3592,7 +3596,7 @@
     for (flow = flows; flow; flow = flow->next) {
       for (blk = flow->blocks; blk; blk = blk->next) {
 	for (line = blk->lines; line; line = line->next) {
-	  n = line->len;
+	  n = line->len.Int();
 	  if (line->hyphenated && (line->next || blk->next)) {
 	    --n;
 	  }
--- xpdf-3.02/xpdf/TextOutputDev.h
+++ xpdf-3.02/xpdf/TextOutputDev.h
@@ -145,7 +145,7 @@
   double *edge;			// "near" edge x or y coord of each char
 				//   (plus one extra entry for the last char)
   int len;			// length of text and edge arrays
-  int size;			// size of text and edge arrays
+  SafeInt size;			// size of text and edge arrays
   int charPos;                  // character position (within content stream)
   int charLen;                  // number of content stream characters in
                                 //   this word
@@ -182,8 +182,8 @@
   TextPool();
   ~TextPool();
 
-  TextWord *getPool(int baseIdx) { return pool[baseIdx - minBaseIdx]; }
-  void setPool(int baseIdx, TextWord *p) { pool[baseIdx - minBaseIdx] = p; }
+  TextWord *getPool(int baseIdx) { return pool[(baseIdx - minBaseIdx).Int()]; }
+  void setPool(int baseIdx, TextWord *p) { pool[(baseIdx - minBaseIdx).Int()] = p; }
 
   int getBaseIdx(double base);
 
@@ -191,8 +191,8 @@
 
 private:
 
-  int minBaseIdx;		// min baseline bucket index
-  int maxBaseIdx;		// max baseline bucket index
+  SafeInt minBaseIdx;		// min baseline bucket index
+  SafeInt maxBaseIdx;		// max baseline bucket index
   TextWord **pool;		// array of linked lists, one for each
 				//   baseline value (multiple of 4 pts)
   TextWord *cursor;		// pointer to last-accessed word
@@ -256,7 +256,7 @@
   double *edge;			// "near" edge x or y coord of each char
 				//   (plus one extra entry for the last char)
   int *col;			// starting column number of each Unicode char
-  int len;			// number of Unicode chars
+  SafeInt len;			// number of Unicode chars
   int convertedLen;		// total number of converted characters
   GBool hyphenated;		// set if last char is a hyphen
   TextLine *next;		// next line in block
@@ -315,7 +315,7 @@
 				//   are built)
   TextLine *lines;		// linked list of lines
   TextLine *curLine;		// most recently added line
-  int nLines;			// number of lines
+  SafeInt nLines;			// number of lines
   int charCount;		// number of characters in the block
   int col;			// starting column
   int nColumns;			// number of columns in the block
@@ -506,7 +506,7 @@
   TextPool *pools[4];		// a "pool" of TextWords for each rotation
   TextFlow *flows;		// linked list of flows
   TextBlock **blocks;		// array of blocks, in yx order
-  int nBlocks;			// number of blocks
+  SafeInt nBlocks;		// number of blocks
   int primaryRot;		// primary rotation
   GBool primaryLR;		// primary direction (true means L-to-R,
 				//   false means R-to-L)
--- xpdf-3.02/xpdf/UnicodeMap.cc
+++ xpdf-3.02/xpdf/UnicodeMap.cc
@@ -39,7 +39,7 @@
   UnicodeMap *map;
   UnicodeMapRange *range;
   UnicodeMapExt *eMap;
-  int size, eMapsSize;
+  SafeInt size, eMapsSize;
   char buf[256];
   int line, nBytes, i, x;
   char *tok1, *tok2, *tok3;
--- xpdf-3.02/xpdf/XPDFCore.cc
+++ xpdf-3.02/xpdf/XPDFCore.cc
@@ -763,7 +763,8 @@
   int nVisuals;
   XColor xcolor;
   XColor *xcolors;
-  int r, g, b, n, m;
+  int r, g, b, n;
+  SafeInt m;
   GBool ok;
 
   // for some reason, querying XmNvisual doesn't work (even if done
@@ -808,13 +809,13 @@
     // set colors in private colormap
     if (installCmap) {
       for (rgbCubeSize = xMaxRGBCube; rgbCubeSize >= 2; --rgbCubeSize) {
-        m = rgbCubeSize * rgbCubeSize * rgbCubeSize;
-        if (XAllocColorCells(display, colormap, False, NULL, 0, colors, m)) {
+        m = SafeInt(rgbCubeSize) * SafeInt(rgbCubeSize) * SafeInt(rgbCubeSize);
+        if (XAllocColorCells(display, colormap, False, NULL, 0, colors, m.Int())) {
           break;
         }
       }
       if (rgbCubeSize >= 2) {
-        m = rgbCubeSize * rgbCubeSize * rgbCubeSize;
+        m = SafeInt(rgbCubeSize) * SafeInt(rgbCubeSize) * SafeInt(rgbCubeSize);
         xcolors = (XColor *)gmallocn(m, sizeof(XColor));
         n = 0;
         for (r = 0; r < rgbCubeSize; ++r) {
@@ -829,7 +830,7 @@
             }
           }
         }
-        XStoreColors(display, colormap, xcolors, m);
+        XStoreColors(display, colormap, xcolors, m.Int());
         gfree(xcolors);
       } else {
         rgbCubeSize = 1;
@@ -1174,7 +1175,7 @@
     w = tile->xMax - tile->xMin;
     h = tile->yMax - tile->yMin;
     image = XCreateImage(display, visual, depth, ZPixmap, 0, NULL, w, h, 8, 0);
-    image->data = (char *)gmalloc(h * image->bytes_per_line);
+    image->data = (char *)gmalloc((SafeInt(h) * SafeInt(image->bytes_per_line)).Int());
     tile->image = image;
   } else {
     image = (XImage *)tile->image;
@@ -1247,9 +1248,9 @@
     }
   } else {
     // do Floyd-Steinberg dithering on the whole bitmap
-    errDownR = (int *)gmallocn(width + 2, sizeof(int));
-    errDownG = (int *)gmallocn(width + 2, sizeof(int));
-    errDownB = (int *)gmallocn(width + 2, sizeof(int));
+    errDownR = (int *)gmallocn(SafeInt(width) + SafeInt(2), sizeof(int));
+    errDownG = (int *)gmallocn(SafeInt(width) + SafeInt(2), sizeof(int));
+    errDownB = (int *)gmallocn(SafeInt(width) + SafeInt(2), sizeof(int));
     errRightR = errRightG = errRightB = 0;
     errDownRightR = errDownRightG = errDownRightB = 0;
     memset(errDownR, 0, (width + 2) * sizeof(int));
--- xpdf-3.02/xpdf/XPDFViewer.cc
+++ xpdf-3.02/xpdf/XPDFViewer.cc
@@ -262,7 +262,7 @@
   ok = gFalse;
 #ifndef DISABLE_OUTLINE
   outlineLabels = NULL;
-  outlineLabelsLength = outlineLabelsSize = 0;
+  outlineLabelsSize = outlineLabelsLength = 0;
   outlinePaneWidth = 175;
 #endif
   viewerTitle = NULL;
@@ -323,7 +323,7 @@
   ok = gFalse;
 #ifndef DISABLE_OUTLINE
   outlineLabels = NULL;
-  outlineLabelsLength = outlineLabelsSize = 0;
+  outlineLabelsSize = outlineLabelsLength = 0;
   outlinePaneWidth = 175;
 #endif
   viewerTitle = NULL;
@@ -2756,7 +2756,7 @@
     }
     gfree(outlineLabels);
     outlineLabels = NULL;
-    outlineLabelsLength = outlineLabelsSize = 0;
+    outlineLabelsSize = outlineLabelsLength = 0;
   }
 
   if (core->getDoc()) {
--- xpdf-3.02/xpdf/XPDFViewer.h
+++ xpdf-3.02/xpdf/XPDFViewer.h
@@ -305,7 +305,7 @@
   Widget outlineTree;
   Widget *outlineLabels;
   int outlineLabelsLength;
-  int outlineLabelsSize;
+  SafeInt outlineLabelsSize;
   Dimension outlinePaneWidth;
 #endif
   XPDFCore *core;
